/* glass : the gamecube linux awesome stream server
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <netinet/in.h>

#include <sys/socket.h>
#include <sys/types.h>

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define PORT 5173
#define BUFFERSIZE 1028

int main(int argc,char **argv){
	char buffer[BUFFERSIZE];
	int mysock,addrsize,i,file,fileoffset,filesize, numpackets, dataread, oldseek;
	struct sockaddr_in myaddr,gcaddr;

	if(argc!=2){
		fprintf(stderr,"\tUsage : %s <filename.iso>\n",argv[0]);
		exit(1);
	}

	file=open(argv[1],O_RDONLY);
	if(file==-1){
		perror(argv[1]);
		exit(1);
	}

	lseek(file, 0, SEEK_SET);
	read(file, buffer, 256);
	buffer[255]=0;
	printf("%c%c%c (",buffer[0],buffer[1],buffer[2]);
	switch(buffer[3]){
		case 'E':
			printf("USA/NTSC");
			break;
		case 'P':
			printf("Europe/PAL");
			break;
		default:
			printf("Japan/NTSC");
	}
	printf(") : %s\n",buffer+32);

	lseek(file, 0, SEEK_SET);
	oldseek=0;

	bzero(&myaddr,sizeof(myaddr));
	myaddr.sin_family=AF_INET;
	myaddr.sin_addr.s_addr=htonl(INADDR_ANY);
	myaddr.sin_port=htons(PORT);

	mysock=socket(AF_INET,SOCK_DGRAM,0);

	bind(mysock,(struct sockaddr *)&myaddr,sizeof(myaddr));

	while(1){
		bzero(&gcaddr,sizeof(gcaddr));
		addrsize=sizeof(gcaddr);
		recvfrom(mysock,buffer,BUFFERSIZE,0,(struct sockaddr *)&gcaddr,&addrsize);

		fileoffset=((int *)buffer)[1];
		fileoffset=ntohl(fileoffset);
		filesize=((int *)buffer)[2];
		filesize=ntohl(filesize);
		numpackets=(filesize/(BUFFERSIZE-4))+1;

		if(fileoffset!=oldseek)
			lseek(file, fileoffset, SEEK_SET);

		for(i=0;i<numpackets;i++){
			if(i+1==numpackets) //last packet
				dataread=read(file, buffer+4, filesize%(BUFFERSIZE-4));
			else
				dataread=read(file, buffer+4, BUFFERSIZE-4);
			buffer[0]=1;
			buffer[2]=i/256;
			buffer[3]=i%256;

			sendto(mysock,buffer,dataread+4,0,(struct sockaddr *)&gcaddr,addrsize);
		}
		//end of stream
		buffer[0]=2;
		sendto(mysock,buffer,4,0,(struct sockaddr *)&gcaddr,addrsize);

		oldseek=fileoffset+filesize;
	}

	close(mysock);
	close(file);
	return 0;
}
